//$Id: dialog-res.h,v 1.1 2001/02/22 21:56:04 cactus Exp $ -*- c++ -*-

/* Guikachu Copyright (C) 2001 RDI Gerg <cactus@cactus.rulez.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef GUIKATCHU_DIALOG_RES_H
#define GUIKATCHU_DIALOG_RES_H

namespace Guikachu
{
    namespace Resources
    {
	class Dialog;

	enum DialogType
	{
	    DIALOG_INFORMATION,
	    DIALOG_CONFIRMATION,
	    DIALOG_WARNING,
	    DIALOG_ERROR
	};
	    
    }
}

#include "resource.h"
#include "dialog-win.h"

#include <vector>

namespace Guikachu
{
    namespace Resources
    {
	class Dialog: public Resource
	{
	private:
	    DialogType dialog_type;
	    string title;
	    string text;
	    string_case help_id;
	    vector <string> buttons;
	    unsigned int default_button;

	    Guikachu::GUI::DialogWindow *gui;
	public:
	    Dialog (const string& name);
	    virtual ~Dialog ();
	    
	    virtual Type get_type () const { return RESOURCE_DIALOG; };
	    virtual void show_ui ();

	    string get_title () { return title; };
	    void set_title (const string& title_) { title = title_; changed (); };

	    string get_text () { return text; };
	    void set_text (const string& text_) { text = text_; changed (); };

	    DialogType get_dialog_type () { return dialog_type; };
	    void set_dialog_type (DialogType dialog_type_) { dialog_type = dialog_type_; changed (); };

	    vector <string> get_buttons () { return buttons; };
	    void set_buttons (const vector <string>& buttons_) { buttons = buttons_; changed (); };

	    unsigned int get_default_button () { return default_button; };
	    void set_default_button (unsigned int num) { default_button = num; changed (); };
	    
	private:
	    virtual bool load (xmlDocPtr xml_doc, xmlNodePtr node);
	    virtual void save (xmlNodePtr node) const;
	    virtual void save_rcp (ostream &ostr) const;
	};
    };
};

#endif /* !GUIKATCHU_DIALOG_RES_H */
